#pragma once
#include "libs.h"
#include "ship.h"

class Player : public Ship {
public:
  OBJDEF(Player, Ship, PLAYER);
  Player(ShipType::Type shipType);
  Player(void) { }
  virtual ~Player(void);
  void PollControls(void);
  virtual void Render(const Frame* camFrame);
  void DrawHUD(const Frame* cam_frame);
  virtual void SetDockedWith(SpaceStation*, int port);
  void TimeStepUpdate(const float timeStep);
private:
  void DrawTargetSquares();
  void DrawTargetSquare(const Body* const target);
  float m_mouseCMov[2];
  bool polledControlsThisTurn;
};

