#pragma once
#include "body.h"
#include "star_system.h"

class Frame;

class Star: public Body {
public:
  OBJDEF(Star, Body, STAR);
  Star(StarSystem::SBody* sbody);
  Star(void) { }
  virtual ~Star(void) { };
  virtual void SetPosition(vector3d p);
  virtual vector3d GetPosition(void) const;
  virtual double GetRadius(void) const { return radius; }
  virtual void Render(const Frame* camFrame);
  virtual double GetMass(void) const { return mass; }

protected:
  virtual void Save(void);
  virtual void Load(void);

private:
  StarSystem::BodyType type;
  vector3d pos;
  double radius;
  double mass;
};

